// f1 = hd, f2 = tl
using System;
using HaskellRTS;
using ListTest;
// using List; using Cons; using Nil;


 namespace HaskellImplementation
 {
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	
	class MainH
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{  
			Console.WriteLine(fac(5));
			Console.WriteLine(fac(new Closure(5)));
			Console.WriteLine(fac(new Closure(new Closure.eval_delegate(delegate5))));
			Console.WriteLine(head(new Cons(fac(new Closure(5)),new Nil())));
			// these two examples show that we need either 
			// to check if the final value is an evaluted closure, or always eval it.
			Console.WriteLine(head(listones));
			Console.WriteLine(((Closure)(head(listonesv2))).eval());
			Console.ReadLine();
			
		}

		public static object delegate5 () {return ((object)5);}

		static int fac (int n)
		{
			switch (n) 
			{
				case 0 : return 1;
				default : return (n * fac (n - 1));
			}

		}

		static int fac (Closure n) 
		{ 
		  n.eval();
		  int x = (int)(n.value);
		  switch (x) {
			 case 0 : return 1;
			// case 0 : return new Closure(1);
			// default: return (x * fac (x - 1));
			// default: return new Closure (x * fac (new Closure ((x - 1))));
			default: return (x * fac (new Closure ((x - 1))));
					 }
		}

		//static object head (List l)
		//{
		//	Cons c = (Cons) l;
		//	return c.f1;
		//}

		static object head (Closure cl) 
		{ 
			cl.eval();
			Cons c = (Cons) cl.value;
			return (c.f1);	
		}

		
        static Closure listones = new Closure(new Cons(1, listones));
		static Closure listonesv2 = new Closure(new Cons(new Closure(1), listonesv2));

		delegate object function_delegate (object o);
		static List map (function_delegate f, Closure l)
		{
				List el = (List) l.eval();
			if (el is Nil) {return new Nil();} 
			else return (new Cons (new Closure (f(((Cons) el).f1)), // this needs to be fixed to be lazy
					               new Closure (map (f, (Closure) ((Cons) el).f2)))); // this needs to be fixed to be lazy            
		}
		static List map (function_delegate f, List l)
		{
			if (l is Nil) {return new Nil();} 
			else return (new Cons (new Closure (f(((Cons) l).f1)), // this needs to be fixed to be lazy
					               new Closure (map (f, (Closure) ((Cons) l).f2)))); // this needs to be fixed to be lazy            
		}
	}
}
